//+------------------------------------------------------------------+
//|                                                         Test.mq5 |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <errordescription.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   int TF[15] = {0,1,5,15,30,60,120,180,240,360,480,720,1440,10080,43200};
   int iMACD_Handle[12];
   
   for(int MACD_TF=1;MACD_TF<=12;MACD_TF++){
      iMACD_Handle[MACD_TF]=iMACD(Symbol(),GetTimeFrame(TF[MACD_TF]),20,60,6,PRICE_CLOSE); 
      if(iMACD_Handle[MACD_TF]==INVALID_HANDLE){
         PrintFormat("iMACD_Handle==INVALID_HANDLE, Symbol=%s, TimeFrame=%s, Error=%d %s",Symbol(),(string)TF[MACD_TF],GetLastError(),ErrorDescription(GetLastError())); 
      }
   };   

   return(INIT_SUCCEEDED);
}
  
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
      
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   
  }
//+------------------------------------------------------------------+

ENUM_TIMEFRAMES GetTimeFrame(int Period_TF){
   ENUM_TIMEFRAMES TF_Array[]={PERIOD_M1,PERIOD_M5,PERIOD_M15,PERIOD_M30,PERIOD_H1,PERIOD_H2,PERIOD_H3,PERIOD_H4,PERIOD_H6,PERIOD_H8,PERIOD_H12,PERIOD_D1};
   ENUM_TIMEFRAMES Enum_TimeFrame=(ENUM_TIMEFRAMES)Period_TF;
   for(int i=0;i<ArraySize(TF_Array);i++){
      if(Period_TF==(int)TF_Array[i])
         Enum_TimeFrame=TF_Array[i];
   }
   return Enum_TimeFrame;
}